#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
using namespace std;
typedef long long LL;
typedef pair<int,int> PII;
typedef vector<int> VI;
#define fname ""
#define pb push_back
#define F first
#define S second
#define mp make_pair
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(s) s.begin(),s.end()
const int maxn = (int)1e6;
const int inf = (1 << 30) - 1;

struct Edge {
	int a, b;
} edge[maxn];

int t, n, m, l, r, d[maxn], bad[maxn], q[maxn];
vector <int> g[maxn];

void bfs(int v) {
	l = r = 0;
	q[r++] = v;

	int id, to;
	for (int i = 1; i <= n; ++i)
		d[i] = inf;
	d[v] = 0;

	while (l < r) {
		v = q[l++];

		for (int i = 0; i < (int)g[v].size(); ++i) {
			id = g[v][i];
			to = edge[id].b;

			if (bad[id])
				continue;

			if (d[to] > d[v] + 1) {
				d[to] = d[v] + 1;
				q[r++] = to;
			}
		}
	}
	return;
}

int main()
{
//	freopen(fname"in", "r", stdin);
//	freopen(fname"out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> t;
	while (t--)
	{
		cin >> n >> m;
		for (int i = 1; i <= n; ++i)
			g[i].clear();
		for (int i = 0; i < m + m; i += 2) {
			cin >> edge[i].a >> edge[i].b;
			g[edge[i].a].pb(i);
			g[edge[i].b].pb(i ^ 1);

			edge[i ^ 1] = edge[i];
			swap(edge[i ^ 1].a, edge[i ^ 1].b);
		}

		int ans = inf;
		for (int i = 0; i < m + m; i += 2) {
			bad[i] = bad[i ^ 1] = true;
			bfs(edge[i].a);
			ans = min(ans, d[edge[i].b] + 1);
			bad[i] = bad[i ^ 1] = false;
		}
		printf("%d\n", ans);
	}
	return 0;
}
