#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
using namespace std;
typedef long long LL;
typedef pair<int,int> PII;
typedef vector<int> VI;
#define fname ""
#define pb push_back
#define F first
#define S second
#define mp make_pair
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(s) s.begin(),s.end()
const int maxn = (int)1e6;
const int inf = (1 << 30) - 1;

int used[20][20], T, n, m;
int dx[4] = {1, 0, -1, 0};
int dy[4] = {0, 1, 0, -1};

bool can(int x, int y, int w, int h) {
	for (int i = x - 1; i <= x + w; ++i)
		for (int j = y - 1; j <= y + h; ++j) {
			if (i < 0 || i >= n || j < 0 || j >= m)
				return false;
			if (used[i][j] == 1)
				return false;
		}
	return true;
}

void dfs(int u, int v) {
	if (used[u][v] != 2)
		return;
	used[u][v] = 0;

	int x, y;
	for (int i = 0; i < 4; ++i) {
		x = u + dx[i];
		y = v + dy[i];

		if (used[x][y] == 2)
			dfs(x, y);
	}
	return;
}

int cur;

void place(int x, int y, int w, int h) {
	for (int i = x - 1; i <= x + w; ++i)
		for (int j = y - 1; j <= y + h; ++j) {
			if (used[i][j] == 2) {
				dfs(i, j);
				cur--;
			}
		}

	for (int i = x; i < x + w; ++i)
		for (int j = y; j < y + h; ++j)
			used[i][j] = 2;
	cur++;
	return;
}

int x, y, w, h, b;

int main()
{
//	freopen(fname"in", "r", stdin);
//	freopen(fname"out", "w", stdout);

	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> T;
	while (T--) {
		cin >> n >> m >> b;
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < m; ++j)
				used[i][j] = 0;
		for (int i = 1; i <= b; ++i) {
			cin >> x >> y >> w >> h; 
			for (int X = x; X < x + w; X++)
				for (int Y = y; Y < y + h; Y++)
					used[X][Y] = 1;
		}

		int ans = 0;
		cur = 0;
		for (int i = 0; i < (int)1e4; ++i) {
			x = rand() % n;
			y = rand() % m;
			if (rand() % 2)
				w = 2, h = 3;
			else
				h = 2, w = 3;

			if (can(x, y, w, h))
				place(x, y, w, h);
			ans = max(ans, cur);
		}
		printf("%d\n", ans);
	}

	return 0;
}
