#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <stack>
#include <algorithm>


#define forn(i, n) for(int i = 0; i < int(n); i++)
#define mp make_pair
#define pb push_back
#define foreach(it, v) for(__typeof(v.begin()) it = v.begin(); it != v.end(); ++it)

using namespace std;

typedef long long ll;

struct Fenwick {
	int n;
	vector < int > tree;
	
	Fenwick(int n) : n(n), tree(n + 1, 0) {}
	
	void add(int i) {
		for(; i <= n; i += i & (-i))
			tree[i]++;
	}
	
	int getSum(int i) {
		int result = 0;
		for(; i > 0; i -= i & -i)
			result += tree[i];
		return result;
	}
	
	int getSum(int l, int r) {
		assert(l <= r);
		return getSum(r) - getSum(l - 1);
	}
};

int main() {
	ios_base::sync_with_stdio(false);
	int tests;
	cin >> tests;
	for(int test = 0; test < tests; test++) {
		const int maxValue = 100000;
		Fenwick tree(maxValue);
		int n;
		cin >> n;
		vector < int > values(n), results(n);
		for(int i = 0; i < n; i++)
			cin >> values[i];
		for(int i = n - 1; i >= 0; i--) {
			if(values[i] > 1)
				results[i] = tree.getSum(1, values[i] - 1);
			tree.add(values[i]);
		}
		for(int i = 0; i < n; i++)
			cout << results[i] << " ";
		cout << endl;
	}
	return 0;
}