#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>

using namespace std;

const int MAX_N = 205;
const int MAX_M = 2005;

int n, m, head[MAX_N], point[MAX_M], next[MAX_M], n_edge, used[MAX_M];

void add_edge(int u, int v) {
    point[n_edge] = v, next[n_edge] = head[u], head[u] = n_edge++;
    point[n_edge] = u, next[n_edge] = head[v], head[v] = n_edge++;
}

int dist(int u, int v) {
    int q[MAX_N], sz_q = 0, d[MAX_N];

    memset(d, -1, sizeof(d));

    d[u] = 0;
    q[sz_q++] = u;

    for (int i = 0; i < sz_q; i++) {
        int u = q[i];

        for (int j = head[u]; j >= 0; j = next[j]) {
            if (used[j]) {
                continue;
            }

            int v = point[j];

            if (d[v] < 0) {
                d[v] = d[u] + 1;
                q[sz_q++] = v;
            }
        }
    }

    if (d[v] < 0) {
        return 1000000000;
    }

    return d[v];
}

int main() {
    cin.sync_with_stdio(false);
    cout.sync_with_stdio(false);

    /*
    freopen("task.in", "r", stdin);
    freopen("task.out", "w", stdout);
    */

    int tests;

    cin >> tests;

    for (int test = 0; test < tests; test++) {
        cin >> n >> m;

        n_edge = 0;
        memset(head, -1, sizeof(head));

        for (int i = 0; i < m; i++) {
            int u, v;

            cin >> u >> v;

            add_edge(u - 1, v - 1);
        }

        int ans = 1000000000;

        for (int i = 0; i < m; i += 2) {
            used[i] = used[i ^ 1] = true;

            ans = min(ans, dist(point[i], point[i ^ 1]) + 1);

            used[i] = used[i ^ 1] = false;
        }

        cout << ans << endl;
    }

    return 0;
}
