#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const int MOD = 2017;
const int MAXK = 12;

int tmp[MAXK][MAXK];
int res[MAXK][MAXK];
int base[MAXK][MAXK];
int n, k;

void
getPow(int st)
{
	while (st != 0) {
		if (st & 1) {
			for (int i = 1; i <= k; ++i) {
				for (int j = 1; j <= k; ++j) {
					tmp[i][j] = 0;
					for (int kk = 1; kk <= k; ++kk) {
						tmp[i][j] += res[i][kk] * base[kk][j];
					}
					tmp[i][j] %= MOD;
				}
			}
			for (int i = 1; i <= k; ++i) {
				for (int j = 1; j <= k; ++j) {
					res[i][j] = tmp[i][j];
				}
			}
		}
		st /= 2;
		for (int i = 1; i <= k; ++i) {
			for (int j = 1; j <= k; ++j) {
				tmp[i][j] = 0;
				for (int kk = 1; kk <= k; ++kk) {
					tmp[i][j] += base[i][kk] * base[kk][j];
				}
				tmp[i][j] %= MOD;
			}
		}
		for (int i = 1; i <= k; ++i) {
			for (int j = 1; j <= k; ++j) {
				base[i][j] = tmp[i][j];
			}
		}
	}
}

void
process()
{
	scanf("%d%d", &n, &k);
	for (int i = 1; i <= k; ++i) {
		for (int j = 1; j <= k; ++j) {
			base[i][j] = res[i][j] = 0;
		}
		res[i][i] = 1;
	}
	base[1][1] = 1;
	for (int i = 2; i <= k; ++i) {
		base[i][i - 1] = 1;
		base[i][i] = i;
	}
	getPow(n - 1);
	int ans = res[k][1];
	printf("%d\n", ans % MOD);
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		process();
	}
	return 0;
}