#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));

int n, m, ans;
int used[30][30];

inline bool check(int x, int y, int w, int h) {
	if (x + w - 1 < n - 1 && y + h - 1 < m - 1) {
		for (int i = x - 1; i <= x + w; ++i) {
			for (int j = y - 1; j <= y + h; ++j) {
				if (used[i][j]) {
					return false;
				}
			}
		}
		return true;
	}
	return false;
}

inline void add(int x, int y, int w, int h, int val) {
	for (int i = 0; i < w; ++i) {
		for (int j = 0; j < h; ++j) {
			used[x + i][y + j] += val;
		}
	}
}

void gen(int x, int y, int z) {
	if (x >= n - 2) {
		ans = max(ans, z);
		return;
	}
	if (y >= m - 2) {
		gen(x + 1, 1, z);
		return;
	}
	if (used[x][y]) {
		gen(x, y + 1, z);
		return;
	}
	if (check(x, y, 2, 3)) {
		add(x, y, 2, 3, 1);
		gen(x, y + 1, z + 1);
		add(x, y, 2, 3, -1);
	}
	if (check(x, y, 3, 2)) {
		add(x, y, 3, 2, 1);
		gen(x, y + 1, z + 1);
		add(x, y, 3, 2, -1);
	}
	gen(x, y + 1, z);
}

inline void solve() {
	int b;
	scanf("%d %d %d", &n, &m, &b);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			used[i][j] = 0;
		}
	}
	for (int i = 0; i < b; ++i) {
		int x, y, w, h;
		scanf("%d %d %d %d", &x, &y, &w, &h);
		for (int j = x; j < x + w; ++j) {
			for (int z = y; z < y + h; ++z) {
				++used[j][z];
			}
		}
	}
	ans = 0;
	gen(1, 1, 0);
	printf("%d\n", ans);
}

int main() {
#ifdef LOCAL42
#define TASK "J"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		solve();
	}
	return 0;
}
